<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.util.Values"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, "net.sf.basedb.reggie", true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
	final String title = "Select aliquots plates to use on MIPs plate";
	String ignore = request.getParameter("ignore");
%>
<base:page type="popup" title="<%=title%>">
<base:head 
	scripts="~select_aliquot_plates.js,~plate.js,~../reggie-2.js"
	styles="~../css/reggie-2.css,~../css/plate.css"
>
<style>

#aliquot-table
{
	width: 100%;
}

#aliquot-table td, #aliquot-table th
{
	padding: 2px 0.5em;
}

#aliquot-table tr.highlight
{
	border-bottom-width: 1px;
	border-bottom-style: dotted;
}
.check
{
	width: 2em;
	text-align: center;
}
.name
{
	text-align: left;
	width: 14em;
}
.image
{
	width: 20px;
}
.count
{
	text-align: center;
	width: 5em;
}
.date
{
	text-align: left;
	width: 6em;
}
.notes
{
	text-align: left;
}

#plate-preview table
{
	margin: 2em auto;
}

#plate-preview caption
{
	font-style: italic;
	margin-bottom: 2px;
}

#plate-preview th
{
	width: 1.75em;
	height: 1.75em;
}

#plate-preview td
{
	width: 2.5em;
	height: 2.5em;
	border-bottom-width: 1px;
	border-bottom-style: dotted;
	border-right-width: 1px;
	border-right-style: dotted;
}

#plate-preview td.aliquot
{
	background-repeat: no-repeat;
	background-position: 50%;
	background-image: url('../images/dot-black.png');
}

#plate-preview td.used
{
	background-image: none;
}

#plate-preview .pool-row th
{
	padding: 0.25em 0.5em;
	border-left-style: dotted;
	border-left-width: 1px;
}

#plate-preview .pool-row div
{
	writing-mode: sideways-lr;
	white-space: nowrap;
	max-height: 4em;
	overflow: hidden;
}

</style>

</base:head>
<base:body>
	<h1><%=title %></h1>

	<div id="page-data" class="datacontainer"
		data-ignore="<%=HTML.encodeTags(ignore)%>"
	></div>

	<form name="reggie" id="wizard" class="wizard">
	<div class="content bottomborder">

		<table id="aliquot-table" class="bottomborder" style="display: none;">
		<tr class="bg-filled-100 bottomborder">
			<th class="check"></th>
			<th class="name">Name</th>
			<th class="image"></th>
			<th class="count">Aliquots</th>
			<th class="count">Remain</th>
			<th class="date">Date</th>
			<th class="notes">Note</th>
		</tr>
		<tbody id="plate-list"></tbody>
		</table>

		<div id="plate-preview"></div>

	</div>
	</form>
	
	<div id="wizard-status" style="position:absolute; top: 3em; left: 2em; right: 2em;"></div>
	
	<base:buttongroup subclass="dialogbuttons" id="dialogbuttons">
		<base:button id="btnOk" title="Ok" />
		<base:button id="close" title="Cancel" />
	</base:buttongroup>
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>